<template>
  <div>
    <div class="top">
      <div class="add-btn" @click="openModal">Add friend</div>
    </div>
    <div v-if="!friends || (friends && !friends.length)" :style="{'margin-top': '100px'}">
      Empty
    </div>
    <div v-if="friends && friends.length" :style="{'margin-top': '30px'}">
      <div class="friend" v-for="(frd, ndx) in friends" :key="ndx">
        <div class="left">
          <div class="avatar">
            <img :ref="`img-${ndx}`" :src="getImage(frd.imageName, `img-${ndx}`)"  alt="">
          </div>
        </div>
        <div class="right">
          <span style="font-weight: bold;">{{ frd.firstName }} {{ frd.lastName }}</span>
          <span></span>
          <span>Login: {{ frd.login }}</span>
          <span>Email: {{ frd.email }}</span>
          <span>Telephone: {{ frd.telephone }}</span>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { FRIENDS } from '@/store/types'
import axios from 'axios'
export default {
  name: 'ProfileFriends',
  computed: {
    friends () {
      return this.$store.getters[FRIENDS.GETTER.GET_FRIENDS]
    }
  },
  methods: {
    openModal () {
      console.log('asd')
      this.$store.commit(FRIENDS.MUTATION.SET_ADD_FRIEND_MODAL, true)
    },
    getImage (imageName, ref) {
      const self = this
      axios.get(`http://localhost:9192/image/get/${imageName}`)
        .then(response => {
          var blob = response.data.picture
          const imageUrl = `data:image/png;base64,${blob}`
          self.$refs[ref][0].src = imageUrl
          // return require(imageUrl)
        }).catch(() => {
          console.log('error loading image')
          console.log('ref', ref)
          console.log('self.$refs[ref]', self.$refs[ref])
          self.$refs[ref][0].src = require(`@/assets/camera.png`)
          // return `@/assets/camera.png`
        })
    },
    onImageError (event) {
      console.log('helllooooooo')
      event.target.src = require(`@/assets/camera.png`)
    }
  },
  async mounted () {
    await this.$store.dispatch(FRIENDS.ACTION.LOAD_FRIENDS)
  }
}
</script>
<style lang="scss" scoped>
.top {
  display: flex;
  justify-content: flex-end;
  .add-btn {
    background: #FF6392;
    padding: 10px 20px;
    color: #fff;
    cursor: pointer;
  }
}

.friend {
  box-shadow: 0px 16px 24px rgba(0, 0, 0, 0.08);
  height: 180px;
  display: flex;
  justify-content: space-between;
  padding: 20px;
  box-sizing: border-box;
  margin-bottom: 50px;

  .left {
    display: flex;
    justify-content: center;
    align-items: center;
    width: 40%;

    .avatar {
      border-radius: 50%;
      overflow: hidden;
      width: 140px;
      height: 140px;
      img {
        width: 100%;
        height: 100%;
        object-fit: cover;
      }
    }
  }

  .right {
    display: flex;
    flex-direction: column;
    align-items: start;
    justify-content: center;
    width: 50%;
  }
}
</style>
